'use strict';

exports.__esModule = true;
exports.executeSelectorExpression = executeSelectorExpression;

var _vm = require('vm');

var _selectorBuilder = require('../client-functions/selectors/selector-builder');

var _selectorBuilder2 = _interopRequireDefault(_selectorBuilder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function executeSelectorExpression(expression, skipVisibilityCheck) {
    var sandbox = {
        Selector: function Selector(fn) {
            var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            if (skipVisibilityCheck) options.visibilityCheck = false;

            var builder = new _selectorBuilder2.default(fn, options, { instantiation: 'Selector' });

            return builder.getFunction();
        }
    };

    var context = (0, _vm.createContext)(sandbox);

    return (0, _vm.runInContext)(expression, context, { displayErrors: false });
}